//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "VisAttr.hpp"
#include "VisCam.hpp"
#include "VisCanvasView.hpp"
#include "VisClass.hpp"
#include "VisCntrl.hpp"
#include "VisComp.hpp"
#include "VisGeom.hpp"
#include "VisLight.hpp"
#include "VisMat.hpp"
#include "VisObj.hpp"
#include "VisPrimitiveObj.hpp"
#include "VisShape.hpp"
#include "VisTex.hpp"
#include "VisTimer.hpp"
#include "VisView.hpp"
#include "VisAbout.hpp"
#include "AboutDemo.h"
#include <Menus.hpp>
#include <stdlib.h>
#include <math.h>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
struct TBoxData{
                TVisMathVector Transform, Dims;
               };

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TVisView *VisView1;
        TVisPerspectiveCamera *OverviewCam;
        TVisAttributes *SceneAttr;
        TVisBox *BoundBox;
        TVisLight *VisLight1;
        TVisRectangle *GroundRect;
        TVisBox *Box;
        TVisMaterial *GroundMat;
        TVisMouseController *VisMouseController1;
        TVisMaterial *BoxMat;
        TVisNode *RoboNode;
        TVisBox *VisBox2;
        TVisMaterial *RoboMat;
        TVisTimer *VisTimer1;
        TVisPerspectiveCamera *RoboCam;
        TVisAttributes *BoundAttr;
        TVisAttributes *RoboAttr;
        TVisCylinder *Wheel1;
        TVisCylinder *Wheel2;
        TVisMaterial *WheelMat;
        TVisCylinder *Wheel3;
        TVisCylinder *Wheel4;
        TVisSphere *RoboSphere;
        TVisMaterial *RoboMat2;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *New1;
        TMenuItem *Exit1;
        TMenuItem *Options1;
        TMenuItem *RoboCam1;
        TMenuItem *OverviewCam1;
        TMenuItem *N1;
        TMenuItem *Fulldetail1;
        TMenuItem *NoDetail1;
        TMenuItem *Help1;
        TMenuItem *About1;
        TMenuItem *AboutDemo1;
        TVisTexture *VisTexture1;
        TVisTexture *VisTexture2;
        TVisBox *FastBox;
        TVisAttributes *FastAttr;
        TVisFog *VisFog1;
        TImage *Image1;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall VisView1Render(TVisView *aView);
        void __fastcall GroundRectAfterInit(TObject *Sender);
        void __fastcall BoxAfterInit(TObject *Sender);
        void __fastcall VisTimer1Timer(TObject *sender, int lagcount);
        void __fastcall New1Click(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall RoboCam1Click(TObject *Sender);
        void __fastcall OverviewCam1Click(TObject *Sender);
        void __fastcall Fulldetail1Click(TObject *Sender);
        void __fastcall NoDetail1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall AboutDemo1Click(TObject *Sender);
        void __fastcall FastBoxAfterInit(TObject *Sender);
private:	// User declarations
  int TurnAngle;  //angle the robot still has to be turned
  boolean OVCam;  //OvervieCam used?
  double SensorData[3];  //data from the scan points
  double speed; //current speed of the robot

public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
