//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VisAttr"
#pragma link "VisCam"
#pragma link "VisCanvasView"
#pragma link "VisClass"
#pragma link "VisComp"
#pragma link "VisLight"
#pragma link "VisMat"
#pragma link "VisObj"
#pragma link "VisPrimitiveObj"
#pragma link "VisShape"
#pragma link "VisTex"
#pragma link "VisView"
#pragma link "VisTimer"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ShpMaterial->Brush->Color = VisMaterial1->ColorDiffuse->Color;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VisView1Render(TVisView *aView)
{
  VisView1->Canvas->DrawTexture(Rect(0,0,VisView1->Width,VisView1->Height),VisTexture1,Rect(0,0,VisTexture1->Bitmap->Width,VisTexture1->Bitmap->Height));
  VisLight1->Render(aView);
  VisAttributes2->Render(aView);
  VisTorus1->Render(aView);
  VisMaterial1->Render(aView);
  VisAttributes1->Render(aView);
  VisSphere1->Render(aView);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnMaterialClick(TObject *Sender)
{
  ColorDlg->Color = ShpMaterial->Brush->Color;
  if (ColorDlg->Execute())
    {
      ShpMaterial->Brush->Color = ColorDlg->Color;
      VisMaterial1->ColorDiffuse->Color = ColorDlg->Color;
      VisView1->InvalidateGL();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrbAlphaChange(TObject *Sender)
{
  VisMaterial1->ColorDiffuse->Alpha = float(TrbAlpha->Position) / 100;
  VisView1->InvalidateGL();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CBTransChange(TObject *Sender)
{
  VisAttributes1->Transparency = (TVisTransparencyMode)(CBTrans->ItemIndex);
  VisView1->InvalidateGL();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VisTimer1Timer(TObject *sender, int lagcount)
{
  VisTorus1->Transformation->Rotation->incY(3);
  VisTorus1->Transformation->Rotation->incX(4);
  VisView1->InvalidateGL();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
  ShowAboutDlg();
}
//---------------------------------------------------------------------------
 