//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>

#include <Math.h>
#include <Forms.hpp>
#include "VisAttr.hpp"
#include "VisAbout.hpp"
#include "VisCam.hpp"
#include "VisCanvasView.hpp"
#include "VisClass.hpp"
#include "VisComp.hpp"
#include "VisGeom.hpp"
#include "VisLight.hpp"
#include "VisMat.hpp"
#include "VisObj.hpp"
#include "VisPrimitiveObj.hpp"
#include "VisShape.hpp"
#include "VisTimer.hpp"
#include "VisView.hpp"
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TVisView *VisView1;
    TVisPerspectiveCamera *VisPerspectiveCamera1;
    TVisNode *VisNode1;
    TVisLight *VisLight1;
    TVisBox *VisBox1;
    TVisRectangle *VisRectangle1;
    TVisLight *VisLight2;
    TVisSphere *VisSphere1;
    TVisAttributes *VisAttributes1;
    TVisAttributes *VisAttributes2;
    TVisTimer *VisTimer1;
    TVisMaterial *VisMaterial1;
    TVisMaterial *VisMaterial3;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Exit1;
    TMenuItem *Options1;
    TMenuItem *Transparency1;
    TMenuItem *Showgrid1;
    TMenuItem *N1;
    TMenuItem *Highdetail1;
    TMenuItem *Lowdetail1;
    TMenuItem *Help1;
    TMenuItem *About1;
    TVisMaterial *VisMaterial2;
        void __fastcall VisView1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall VisView1MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall VisView1MouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall VisView1Render(TVisView *aView);
        void __fastcall VisSphere1AfterInit(TObject *Sender);
        void __fastcall VisTimer1Timer(TObject *sender, int lagcount);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall Showgrid1Click(TObject *Sender);
        void __fastcall Highdetail1Click(TObject *Sender);
        void __fastcall Lowdetail1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall Transparency1Click(TObject *Sender);

private:	// User declarations
     TVisMathVector velocity;
     boolean DoDrag;
     TVisMathVector DragDist;
     TPoint MousePos, OldPos;

public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
 