//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VisAttr"
#pragma link "VisCam"
#pragma link "VisCanvasView"
#pragma link "VisClass"
#pragma link "VisComp"
#pragma link "VisLight"
#pragma link "VisMat"
#pragma link "VisObj"
#pragma link "VisPoly"
#pragma link "VisPrimitiveObj"
#pragma link "VisShape"
#pragma link "VisTimer"
#pragma link "VisView"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  CurStep=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DoStep()
{
  Form1->Edit2->Text=Form1->Edit1->Text;
  switch (CurStep)
  {
    case 0://init polygon
      {
        Form1->Polygon->Init();
        Form1->Sphere->Enabled=false;
        Form1->VisAttributes1->Lighting=false;
        Form1->Edit1->Text="Polygon->Extrude(0.2, 3, false);";
        break;
       }
     case 1:
      {
        Form1->Polygon->Extrude(0.15, 3, false);
        Form1->VisAttributes1->Lighting=true;
        Form1->Edit1->Text="Polygon->Extrude(0.15, 3, false);";
        break;
      }
     case 2:
      {
        Form1->Polygon->Extrude(0.15, 3, false);
        Form1->Edit1->Text="Sphere->Enabled=true;  Sphere->Init();";
        break;
      }

    case 3:
      {
        Form1->Sphere->Enabled=true;
        Form1->Sphere->Init();
        Form1->VisAttributes2->CullFace=cfNone;
        Form1->Edit1->Text="Sphere->FreePoints(10,150);";
        break;
      }
    case 4:
      {
        Form1->Sphere->FreePoints(10,150);
        Form1->Edit1->Text="Sphere->Extrude(-0.1, 3, false);";
        break;
      }
    case 5:
      {
        Form1->Sphere->Extrude(-0.1, 3, false);
        Form1->VisAttributes2->CullFace=cfBack;
        Form1->Edit1->Text="<reset scene>";
        break;
      }
 }
 CurStep=(CurStep+1) % 6;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  DoStep();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VisView1Render(TVisView *aView)
{
   VisNode1->Render(aView);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
 DoStep();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
 if (CheckBox1->Checked)
   {
     VisAttributes1->PolygonMode=pmLine;
     VisAttributes2->PolygonMode=pmLine;
   }
 else
   {
     VisAttributes1->PolygonMode=pmFill;
     VisAttributes2->PolygonMode=pmFill;
   }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
  ShowAboutDlg();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VisTimer1Timer(TObject *sender, int lagcount)
{
 Polygon->Transformation->Rotation->incX(3);
 Polygon->Transformation->Rotation->incY(4);
 Sphere->Transformation->Rotation->incX(3);
 Sphere->Transformation->Rotation->incZ(1);
 VisView1->InvalidateGL();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PolygonConstruct(TObject *Sender)
{
  Polygon->AddValues(0  ,0  ,0,0,0);
  Polygon->AddValues(0.5,0  ,0,0,0);
  Polygon->AddValues(0.3,0.3,0,0,0);
  Polygon->AddValues(0  ,0.5,0,0,0);
  Polygon->CalcNormals();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SphereBeforeRender(TVisCustomView *aView)
{
  VisView1->DrawValues=VisView1->DrawValues>>dvDepth;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SphereAfterRender(TVisCustomView *aView)
{
  VisView1->DrawValues=VisView1->DrawValues<<dvDepth;        
}
//---------------------------------------------------------------------------

