//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "VisAttr.hpp"
#include "VisCam.hpp"
#include "VisCanvasView.hpp"
#include "VisClass.hpp"
#include "VisComp.hpp"
#include "VisLight.hpp"
#include "VisMat.hpp"
#include "VisObj.hpp"
#include "VisPoly.hpp"
#include "VisPrimitiveObj.hpp"
#include "VisShape.hpp"
#include "VisTimer.hpp"
#include "VisAbout.hpp"
#include "VisView.hpp"
#include <ExtCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TCheckBox *CheckBox1;
        TPanel *Panel1;
        TPanel *Panel2;
        TEdit *Edit1;
        TEdit *Edit2;
        TMenuItem *About1;
        TMenuItem *Exit1;
        TMenuItem *File1;
        TMenuItem *Help1;
        TButton *Button1;
        TLabel  *Label1;
        TMainMenu *MainMenu1;

        TVisNode *VisNode1;
        TVisAttributes *VisAttributes1;
        TVisAttributes *VisAttributes2;
        TVisPolygon *Polygon;
        TVisSphere *Sphere;
        TVisLight *VisLight1;
        TVisMaterial *VisMaterial1;
        TVisMaterial *VisMaterial2;
        TVisPerspectiveCamera *VisPerspectiveCamera1;
        TVisTimer *VisTimer1;        
        TVisView *VisView1;

        void __fastcall FormCreate(TObject *Sender);
        void __fastcall VisView1Render(TVisView *aView);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall VisTimer1Timer(TObject *sender, int lagcount);
        void __fastcall PolygonConstruct(TObject *Sender);
        void __fastcall SphereBeforeRender(TVisCustomView *aView);
        void __fastcall SphereAfterRender(TVisCustomView *aView);
private:	// User declarations
        int CurStep;
public:		// User declarations
        void __fastcall TForm1::DoStep();
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
 