//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "VisAttr.hpp"
#include "VisCam.hpp"
#include "VisCanvasView.hpp"
#include "VisClass.hpp"
#include "VisComp.hpp"
#include "VisLight.hpp"
#include "VisMat.hpp"
#include "VisObj.hpp"
#include "VisPrimitiveObj.hpp"
#include "VisShape.hpp"
#include "VisTex.hpp"
#include "VisView.hpp"
#include "VisAbout.hpp"
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "VisTimer.hpp"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TVisView *VisView1;
        TPanel *Panel1;
        TLabel *LblMaterial;
        TShape *ShpMaterial;
        TLabel *Label2;
        TBevel *Bevel2;
        TLabel *LblAlpha;
        TLabel *Label3;
        TButton *BtnMaterial;
        TTrackBar *TrbAlpha;
        TComboBox *CBTrans;
        TVisPerspectiveCamera *VisPerspectiveCamera1;
        TVisAttributes *VisAttributes1;
        TVisAttributes *VisAttributes2;
        TVisLight *VisLight1;
        TVisMaterial *VisMaterial1;
        TColorDialog *ColorDlg;
        TVisSphere *VisSphere1;
        TMainMenu *MainMenu;
        TMenuItem *N1;
        TVisTexture *VisTexture1;
        TVisTorus *VisTorus1; 
        TVisTimer *VisTimer1;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall VisView1Render(TVisView *aView);
        void __fastcall BtnMaterialClick(TObject *Sender);
        void __fastcall TrbAlphaChange(TObject *Sender);
        void __fastcall CBTransChange(TObject *Sender);
        void __fastcall VisTimer1Timer(TObject *sender, int lagcount);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
  private:	// User declarations
  public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
    